
/*  © Copyright CERN, 2015. All rights not expressly granted are reserved.

    The stub of this file was generated by quasar (https://github.com/quasar-team/quasar/)

    Quasar is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public Licence as published by
    the Free Software Foundation, either version 3 of the Licence.
    Quasar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public Licence for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Quasar.  If not, see <http://www.gnu.org/licenses/>.

    
 */


#include <Configuration.hxx>	// TODO; should go away, is already in Base class for ages

#include <DLArLevelMeter.h>
#include <ASLArLevelMeter.h>


namespace Device
{
  // 1111111111111111111111111111111111111111111111111111111111111111111111111
  // 1     GENERATED CODE STARTS HERE AND FINISHES AT SECTION 2              1
  // 1     Users don't modify this code!!!!                                  1
  // 1     If you modify this code you may start a fire or a flood somewhere,1
  // 1     and some human being may possible cease to exist. You don't want  1
  // 1     to be charged with that!                                          1
  // 1111111111111111111111111111111111111111111111111111111111111111111111111






  // 2222222222222222222222222222222222222222222222222222222222222222222222222
  // 2     SEMI CUSTOM CODE STARTS HERE AND FINISHES AT SECTION 3            2
  // 2     (code for which only stubs were generated automatically)          2
  // 2     You should add the implementation but dont alter the headers      2
  // 2     (apart from constructor, in which you should complete initializati2
  // 2     on list)                                                          2
  // 2222222222222222222222222222222222222222222222222222222222222222222222222

  /* sample ctr */
  DLArLevelMeter::DLArLevelMeter (const Configuration::LArLevelMeter & config,
				  Parent_DLArLevelMeter *
				  parent):Base_DLArLevelMeter (config, parent)
    /* fill up constructor initialization list here */
  {
	LOG(Log::INF) << "Connecting to board at " << config.board_address();
	lar_level = new larLevelDaqLib(config.board_address().c_str()); // numero IP

	if(lar_level->isConnected()){
	  lar_level->unSetTemperatureConversion();
	  lar_level->UpdateDACAValue(0x0F/*tous les channel*/,0x7f); // inner offset of AD7746

	  // there are 12 physical channels on the electronics. But there are only 8 level meters (4 for each top CRPs)
	  // we read and store the 12 channels, the mapping will be handle

	  // we do not read the inner temperature of the AD7746, we don't need them
	  lar_level->unSetTemperatureConversion();
	}
  }

  /* sample dtr */
  DLArLevelMeter::~DLArLevelMeter ()
  {
  }

  /* delegates for cachevariables */



  /* delegators for methods */

  // 3333333333333333333333333333333333333333333333333333333333333333333333333
  // 3     FULLY CUSTOM CODE STARTS HERE                                     3
  // 3     Below you put bodies for custom methods defined for this class.   3
  // 3     You can do whatever you want, but please be decent.               3
  // 3333333333333333333333333333333333333333333333333333333333333333333333333

  void DLArLevelMeter::update()
  {
//	  LOG(Log::INF) << "Update";
	  if(lar_level->isConnected()){
		  // Start 1 conversion for all channels
		  lar_level->startConversion();

		  //wait for conversion to finish and read the capacitance from board
		  lar_level->loadData();


		  // then do something with the capacitance (capacitance in pF)
		  // for(int ia=0;ia<12;ia++){
			//   double capa=lar_level->getCapa(ia);
			//   printf("%f  ",capa);
		  // }
		  // printf("\n");

		  auto *as = getAddressSpaceLink();
		  as->setCapacitance00(lar_level->getCapa(0), OpcUa_Good);
		  as->setCapacitance01(lar_level->getCapa(1), OpcUa_Good);
		  as->setCapacitance02(lar_level->getCapa(2), OpcUa_Good);
		  as->setCapacitance03(lar_level->getCapa(3), OpcUa_Good);
		  as->setCapacitance04(lar_level->getCapa(4), OpcUa_Good);
		  as->setCapacitance05(lar_level->getCapa(5), OpcUa_Good);
		  as->setCapacitance06(lar_level->getCapa(6), OpcUa_Good);
		  as->setCapacitance07(lar_level->getCapa(7), OpcUa_Good);
		  as->setCapacitance08(lar_level->getCapa(8), OpcUa_Good);
		  as->setCapacitance09(lar_level->getCapa(9), OpcUa_Good);
		  as->setCapacitance10(lar_level->getCapa(10), OpcUa_Good);
		  as->setCapacitance11(lar_level->getCapa(11), OpcUa_Good);
	  }
  }
}
